-- Do not edit.  Generated on Fri Feb 14 11:50:20 2020 by tgingold
-- With Cheby 1.4.dev0 and these options:
--  -i plc_urv_regs.cheby --gen-hdl plc_urv_regs.vhd


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

entity plc_urv_regs is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_i                 : in    t_wishbone_slave_in;
    wb_o                 : out   t_wishbone_slave_out;

    -- Mailbox to the fip urv
    mailboxes_mboxout_o  : out   std_logic_vector(31 downto 0);
    mailboxes_mboxout_wr_o : out   std_logic;

    -- Mailbox from the fip urv
    mailboxes_mboxin_i   : in    std_logic_vector(31 downto 0);
    mailboxes_mboxin_rd_o : out   std_logic;

    -- Status for mailboxes
    mailboxes_status_mbin_i : in    std_logic;
    mailboxes_status_mbout_i : in    std_logic;

    -- presence lines for boards
    presence_en_i        : in    std_logic_vector(7 downto 0);

    -- REG pins_0
    loops_pins_0_i       : in    std_logic_vector(31 downto 0);

    -- REG pins_1
    loops_pins_1_i       : in    std_logic_vector(31 downto 0);

    -- REG pins_2
    loops_pins_2_i       : in    std_logic_vector(31 downto 0);

    -- REG pins_3
    loops_pins_3_i       : in    std_logic_vector(31 downto 0);

    -- REG pins_4
    loops_pins_4_i       : in    std_logic_vector(31 downto 0);

    -- REG pins_5
    loops_pins_5_i       : in    std_logic_vector(31 downto 0);

    -- REG pins_6
    loops_pins_6_i       : in    std_logic_vector(31 downto 0);

    -- REG pins_7
    loops_pins_7_i       : in    std_logic_vector(31 downto 0);

    -- REG pins_0
    relays_pins_0_o      : out   std_logic_vector(31 downto 0);

    -- REG pins_1
    relays_pins_1_o      : out   std_logic_vector(31 downto 0);

    -- REG pins_2
    relays_pins_2_o      : out   std_logic_vector(31 downto 0);

    -- REG pins_3
    relays_pins_3_o      : out   std_logic_vector(31 downto 0);

    -- REG pins_4
    relays_pins_4_o      : out   std_logic_vector(31 downto 0);

    -- REG pins_5
    relays_pins_5_o      : out   std_logic_vector(31 downto 0);

    -- REG pins_6
    relays_pins_6_o      : out   std_logic_vector(31 downto 0);

    -- REG pins_7
    relays_pins_7_o      : out   std_logic_vector(31 downto 0)
  );
end plc_urv_regs;

architecture syn of plc_urv_regs is
  signal adr_int                        : std_logic_vector(6 downto 2);
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal mailboxes_mboxout_wreq         : std_logic;
  signal relays_pins_0_reg              : std_logic_vector(31 downto 0);
  signal relays_pins_0_wreq             : std_logic;
  signal relays_pins_0_wack             : std_logic;
  signal relays_pins_1_reg              : std_logic_vector(31 downto 0);
  signal relays_pins_1_wreq             : std_logic;
  signal relays_pins_1_wack             : std_logic;
  signal relays_pins_2_reg              : std_logic_vector(31 downto 0);
  signal relays_pins_2_wreq             : std_logic;
  signal relays_pins_2_wack             : std_logic;
  signal relays_pins_3_reg              : std_logic_vector(31 downto 0);
  signal relays_pins_3_wreq             : std_logic;
  signal relays_pins_3_wack             : std_logic;
  signal relays_pins_4_reg              : std_logic_vector(31 downto 0);
  signal relays_pins_4_wreq             : std_logic;
  signal relays_pins_4_wack             : std_logic;
  signal relays_pins_5_reg              : std_logic_vector(31 downto 0);
  signal relays_pins_5_wreq             : std_logic;
  signal relays_pins_5_wack             : std_logic;
  signal relays_pins_6_reg              : std_logic_vector(31 downto 0);
  signal relays_pins_6_wreq             : std_logic;
  signal relays_pins_6_wack             : std_logic;
  signal relays_pins_7_reg              : std_logic_vector(31 downto 0);
  signal relays_pins_7_wreq             : std_logic;
  signal relays_pins_7_wack             : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(6 downto 2);
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_sel_d0                      : std_logic_vector(3 downto 0);
begin

  -- WB decode signals
  adr_int <= wb_i.adr(6 downto 2);
  wb_en <= wb_i.cyc and wb_i.stb;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_i.we)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_i.we) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_i.we)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_i.we) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_o.ack <= ack_int;
  wb_o.stall <= not ack_int and wb_en;
  wb_o.rty <= '0';
  wb_o.err <= '0';

  -- pipelining for wr-in+rd-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_ack_int <= '0';
        wr_req_d0 <= '0';
      else
        rd_ack_int <= rd_ack_d0;
        wb_o.dat <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_adr_d0 <= adr_int;
        wr_dat_d0 <= wb_i.dat;
        wr_sel_d0 <= wb_i.sel;
      end if;
    end if;
  end process;

  -- Register mailboxes_mboxout
  mailboxes_mboxout_o <= wr_dat_d0;
  mailboxes_mboxout_wr_o <= mailboxes_mboxout_wreq;

  -- Register mailboxes_mboxin

  -- Register mailboxes_status

  -- Register presence

  -- Register loops_pins_0

  -- Register loops_pins_1

  -- Register loops_pins_2

  -- Register loops_pins_3

  -- Register loops_pins_4

  -- Register loops_pins_5

  -- Register loops_pins_6

  -- Register loops_pins_7

  -- Register relays_pins_0
  relays_pins_0_o <= relays_pins_0_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        relays_pins_0_reg <= "00000000000000000000000000000000";
        relays_pins_0_wack <= '0';
      else
        if relays_pins_0_wreq = '1' then
          relays_pins_0_reg <= wr_dat_d0;
        end if;
        relays_pins_0_wack <= relays_pins_0_wreq;
      end if;
    end if;
  end process;

  -- Register relays_pins_1
  relays_pins_1_o <= relays_pins_1_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        relays_pins_1_reg <= "00000000000000000000000000000000";
        relays_pins_1_wack <= '0';
      else
        if relays_pins_1_wreq = '1' then
          relays_pins_1_reg <= wr_dat_d0;
        end if;
        relays_pins_1_wack <= relays_pins_1_wreq;
      end if;
    end if;
  end process;

  -- Register relays_pins_2
  relays_pins_2_o <= relays_pins_2_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        relays_pins_2_reg <= "00000000000000000000000000000000";
        relays_pins_2_wack <= '0';
      else
        if relays_pins_2_wreq = '1' then
          relays_pins_2_reg <= wr_dat_d0;
        end if;
        relays_pins_2_wack <= relays_pins_2_wreq;
      end if;
    end if;
  end process;

  -- Register relays_pins_3
  relays_pins_3_o <= relays_pins_3_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        relays_pins_3_reg <= "00000000000000000000000000000000";
        relays_pins_3_wack <= '0';
      else
        if relays_pins_3_wreq = '1' then
          relays_pins_3_reg <= wr_dat_d0;
        end if;
        relays_pins_3_wack <= relays_pins_3_wreq;
      end if;
    end if;
  end process;

  -- Register relays_pins_4
  relays_pins_4_o <= relays_pins_4_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        relays_pins_4_reg <= "00000000000000000000000000000000";
        relays_pins_4_wack <= '0';
      else
        if relays_pins_4_wreq = '1' then
          relays_pins_4_reg <= wr_dat_d0;
        end if;
        relays_pins_4_wack <= relays_pins_4_wreq;
      end if;
    end if;
  end process;

  -- Register relays_pins_5
  relays_pins_5_o <= relays_pins_5_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        relays_pins_5_reg <= "00000000000000000000000000000000";
        relays_pins_5_wack <= '0';
      else
        if relays_pins_5_wreq = '1' then
          relays_pins_5_reg <= wr_dat_d0;
        end if;
        relays_pins_5_wack <= relays_pins_5_wreq;
      end if;
    end if;
  end process;

  -- Register relays_pins_6
  relays_pins_6_o <= relays_pins_6_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        relays_pins_6_reg <= "00000000000000000000000000000000";
        relays_pins_6_wack <= '0';
      else
        if relays_pins_6_wreq = '1' then
          relays_pins_6_reg <= wr_dat_d0;
        end if;
        relays_pins_6_wack <= relays_pins_6_wreq;
      end if;
    end if;
  end process;

  -- Register relays_pins_7
  relays_pins_7_o <= relays_pins_7_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        relays_pins_7_reg <= "00000000000000000000000000000000";
        relays_pins_7_wack <= '0';
      else
        if relays_pins_7_wreq = '1' then
          relays_pins_7_reg <= wr_dat_d0;
        end if;
        relays_pins_7_wack <= relays_pins_7_wreq;
      end if;
    end if;
  end process;

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, relays_pins_0_wack, relays_pins_1_wack, relays_pins_2_wack, relays_pins_3_wack, relays_pins_4_wack, relays_pins_5_wack, relays_pins_6_wack, relays_pins_7_wack) begin
    mailboxes_mboxout_wreq <= '0';
    relays_pins_0_wreq <= '0';
    relays_pins_1_wreq <= '0';
    relays_pins_2_wreq <= '0';
    relays_pins_3_wreq <= '0';
    relays_pins_4_wreq <= '0';
    relays_pins_5_wreq <= '0';
    relays_pins_6_wreq <= '0';
    relays_pins_7_wreq <= '0';
    case wr_adr_d0(6 downto 2) is
    when "00000" => 
      -- Reg mailboxes_mboxout
      mailboxes_mboxout_wreq <= wr_req_d0;
      wr_ack_int <= wr_req_d0;
    when "00001" => 
      -- Reg mailboxes_mboxin
      wr_ack_int <= wr_req_d0;
    when "00010" => 
      -- Reg mailboxes_status
      wr_ack_int <= wr_req_d0;
    when "00100" => 
      -- Reg presence
      wr_ack_int <= wr_req_d0;
    when "01000" => 
      -- Reg loops_pins_0
      wr_ack_int <= wr_req_d0;
    when "01001" => 
      -- Reg loops_pins_1
      wr_ack_int <= wr_req_d0;
    when "01010" => 
      -- Reg loops_pins_2
      wr_ack_int <= wr_req_d0;
    when "01011" => 
      -- Reg loops_pins_3
      wr_ack_int <= wr_req_d0;
    when "01100" => 
      -- Reg loops_pins_4
      wr_ack_int <= wr_req_d0;
    when "01101" => 
      -- Reg loops_pins_5
      wr_ack_int <= wr_req_d0;
    when "01110" => 
      -- Reg loops_pins_6
      wr_ack_int <= wr_req_d0;
    when "01111" => 
      -- Reg loops_pins_7
      wr_ack_int <= wr_req_d0;
    when "10000" => 
      -- Reg relays_pins_0
      relays_pins_0_wreq <= wr_req_d0;
      wr_ack_int <= relays_pins_0_wack;
    when "10001" => 
      -- Reg relays_pins_1
      relays_pins_1_wreq <= wr_req_d0;
      wr_ack_int <= relays_pins_1_wack;
    when "10010" => 
      -- Reg relays_pins_2
      relays_pins_2_wreq <= wr_req_d0;
      wr_ack_int <= relays_pins_2_wack;
    when "10011" => 
      -- Reg relays_pins_3
      relays_pins_3_wreq <= wr_req_d0;
      wr_ack_int <= relays_pins_3_wack;
    when "10100" => 
      -- Reg relays_pins_4
      relays_pins_4_wreq <= wr_req_d0;
      wr_ack_int <= relays_pins_4_wack;
    when "10101" => 
      -- Reg relays_pins_5
      relays_pins_5_wreq <= wr_req_d0;
      wr_ack_int <= relays_pins_5_wack;
    when "10110" => 
      -- Reg relays_pins_6
      relays_pins_6_wreq <= wr_req_d0;
      wr_ack_int <= relays_pins_6_wack;
    when "10111" => 
      -- Reg relays_pins_7
      relays_pins_7_wreq <= wr_req_d0;
      wr_ack_int <= relays_pins_7_wack;
    when others =>
      wr_ack_int <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (adr_int, rd_req_int, mailboxes_mboxin_i, mailboxes_status_mbin_i, mailboxes_status_mbout_i, presence_en_i, loops_pins_0_i, loops_pins_1_i, loops_pins_2_i, loops_pins_3_i, loops_pins_4_i, loops_pins_5_i, loops_pins_6_i, loops_pins_7_i, relays_pins_0_reg, relays_pins_1_reg, relays_pins_2_reg, relays_pins_3_reg, relays_pins_4_reg, relays_pins_5_reg, relays_pins_6_reg, relays_pins_7_reg) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    mailboxes_mboxin_rd_o <= '0';
    case adr_int(6 downto 2) is
    when "00000" => 
      -- Reg mailboxes_mboxout
      rd_ack_d0 <= rd_req_int;
    when "00001" => 
      -- Reg mailboxes_mboxin
      mailboxes_mboxin_rd_o <= rd_req_int;
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= mailboxes_mboxin_i;
    when "00010" => 
      -- Reg mailboxes_status
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0(0) <= mailboxes_status_mbin_i;
      rd_dat_d0(1) <= mailboxes_status_mbout_i;
      rd_dat_d0(31 downto 2) <= (others => '0');
    when "00100" => 
      -- Reg presence
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0(7 downto 0) <= presence_en_i;
      rd_dat_d0(31 downto 8) <= (others => '0');
    when "01000" => 
      -- Reg loops_pins_0
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= loops_pins_0_i;
    when "01001" => 
      -- Reg loops_pins_1
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= loops_pins_1_i;
    when "01010" => 
      -- Reg loops_pins_2
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= loops_pins_2_i;
    when "01011" => 
      -- Reg loops_pins_3
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= loops_pins_3_i;
    when "01100" => 
      -- Reg loops_pins_4
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= loops_pins_4_i;
    when "01101" => 
      -- Reg loops_pins_5
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= loops_pins_5_i;
    when "01110" => 
      -- Reg loops_pins_6
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= loops_pins_6_i;
    when "01111" => 
      -- Reg loops_pins_7
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= loops_pins_7_i;
    when "10000" => 
      -- Reg relays_pins_0
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= relays_pins_0_reg;
    when "10001" => 
      -- Reg relays_pins_1
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= relays_pins_1_reg;
    when "10010" => 
      -- Reg relays_pins_2
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= relays_pins_2_reg;
    when "10011" => 
      -- Reg relays_pins_3
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= relays_pins_3_reg;
    when "10100" => 
      -- Reg relays_pins_4
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= relays_pins_4_reg;
    when "10101" => 
      -- Reg relays_pins_5
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= relays_pins_5_reg;
    when "10110" => 
      -- Reg relays_pins_6
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= relays_pins_6_reg;
    when "10111" => 
      -- Reg relays_pins_7
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= relays_pins_7_reg;
    when others =>
      rd_ack_d0 <= rd_req_int;
    end case;
  end process;
end syn;
