#ifndef __CHEBY__PLC_URV_REGS__H__
#define __CHEBY__PLC_URV_REGS__H__

#include "mbox_regs.h"
#define PLC_URV_REGS_SIZE 96

/* None */
#define PLC_URV_REGS_MAILBOXES 0x0UL
#define PLC_URV_REGS_MAILBOXES_SIZE 16

/* presence lines for boards */
#define PLC_URV_REGS_PRESENCE 0x10UL
#define PLC_URV_REGS_PRESENCE_EN_MASK 0xffUL
#define PLC_URV_REGS_PRESENCE_EN_SHIFT 0

/* None */
#define PLC_URV_REGS_LOOPS 0x20UL
#define PLC_URV_REGS_LOOPS_SIZE 32

/* None */
#define PLC_URV_REGS_LOOPS_PINS_0 0x20UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_1 0x24UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_2 0x28UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_3 0x2cUL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_4 0x30UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_5 0x34UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_6 0x38UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_7 0x3cUL

/* None */
#define PLC_URV_REGS_RELAYS 0x40UL
#define PLC_URV_REGS_RELAYS_SIZE 32

/* None */
#define PLC_URV_REGS_RELAYS_PINS_0 0x40UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_1 0x44UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_2 0x48UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_3 0x4cUL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_4 0x50UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_5 0x54UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_6 0x58UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_7 0x5cUL

struct plc_urv_regs {
  /* [0x0]: SUBMAP (no description) */
  struct mbox_regs mailboxes;

  /* padding to: 4 words */
  uint32_t __padding_0[1];

  /* [0x10]: REG (ro) presence lines for boards */
  uint32_t presence;

  /* padding to: 8 words */
  uint32_t __padding_1[3];

  /* [0x20]: BLOCK (no description) */
  struct loops {
    /* [0x0]: REG (ro) (no description) */
    uint32_t pins_0;

    /* [0x4]: REG (ro) (no description) */
    uint32_t pins_1;

    /* [0x8]: REG (ro) (no description) */
    uint32_t pins_2;

    /* [0xc]: REG (ro) (no description) */
    uint32_t pins_3;

    /* [0x10]: REG (ro) (no description) */
    uint32_t pins_4;

    /* [0x14]: REG (ro) (no description) */
    uint32_t pins_5;

    /* [0x18]: REG (ro) (no description) */
    uint32_t pins_6;

    /* [0x1c]: REG (ro) (no description) */
    uint32_t pins_7;
  } loops;

  /* [0x40]: BLOCK (no description) */
  struct relays {
    /* [0x0]: REG (rw) (no description) */
    uint32_t pins_0;

    /* [0x4]: REG (rw) (no description) */
    uint32_t pins_1;

    /* [0x8]: REG (rw) (no description) */
    uint32_t pins_2;

    /* [0xc]: REG (rw) (no description) */
    uint32_t pins_3;

    /* [0x10]: REG (rw) (no description) */
    uint32_t pins_4;

    /* [0x14]: REG (rw) (no description) */
    uint32_t pins_5;

    /* [0x18]: REG (rw) (no description) */
    uint32_t pins_6;

    /* [0x1c]: REG (rw) (no description) */
    uint32_t pins_7;
  } relays;
};

#endif /* __CHEBY__PLC_URV_REGS__H__ */
